﻿Imports System.IO
Imports System.Threading

Public Class Form1
    Dim threFileView As Thread = Nothing '스레드 생성
    Private Delegate Sub OnFileDelegate(ByVal fp As String, ByVal fn As String, ByVal fl As String, ByVal fc As String)
    Private OnFile As OnFileDelegate = Nothing '델리게이트 선언
    Dim Flag As Boolean = True '일반 / 히든 파일 구분
    Dim DirCount As Integer = 0
    Dim FileCount As Integer = 0

    Private Sub btnPath_Click(sender As Object, e As EventArgs) Handles btnPath.Click
        If Me.fbdFolder.ShowDialog() = DialogResult.OK Then
            ItemsClear()
            Me.txtPath.Text = Me.fbdFolder.SelectedPath
            threFileView = New Thread(New ParameterizedThreadStart(AddressOf FileView))
            threFileView.Start(Me.fbdFolder.SelectedPath)
        End If
    End Sub

    Private Sub ItemsClear()
        DirCount = 0
        FileCount = 0
        Me.lvFile.Items.Clear()
    End Sub

    Private Sub FileView(ByVal path As Object)
        DirCount += 1
        Dim di As DirectoryInfo = New DirectoryInfo(CStr(path))
        Dim dti As DirectoryInfo() = di.GetDirectories()

        For Each f As FileInfo In di.GetFiles
            If Flag = True Then
                FileCount += 1
                Invoke(OnFile, f.DirectoryName, f.Name, f.Length.ToString(), f.CreationTime.ToString())
            Else
                If f.Attributes.ToString().Contains(FileAttributes.Hidden.ToString()) Then
                    FileCount += 1
                    Invoke(OnFile, f.DirectoryName, f.Name, f.Length.ToString(), f.CreationTime.ToString())
                End If
            End If
        Next

        For i As Integer = 0 To di.GetDirectories().Length
            Try
                FileView(dti(i).FullName)
            Catch ex As Exception
                Continue For
            End Try
        Next
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        OnFile = New OnFileDelegate(AddressOf FileResult)
    End Sub

    Private Sub rbtnAll_CheckedChanged(sender As Object, e As EventArgs) Handles rbtnAll.CheckedChanged
        ItemsClear()
        Flag = True
        If threFileView IsNot Nothing Then threFileView.Abort()
        If Me.txtPath.Text <> "" Then
            Me.lvFile.Items.Clear()
            threFileView = New Thread(New ParameterizedThreadStart(AddressOf FileView))
            threFileView.Start(Me.fbdFolder.SelectedPath)
        End If
    End Sub

    Private Sub rbtnHidden_CheckedChanged(sender As Object, e As EventArgs) Handles rbtnHidden.CheckedChanged
        ItemsClear()
        Flag = False
        If threFileView IsNot Nothing Then threFileView.Abort()
        If Me.txtPath.Text <> "" Then
            Me.lvFile.Items.Clear()
            threFileView = New Thread(New ParameterizedThreadStart(AddressOf FileView))
            threFileView.Start(Me.fbdFolder.SelectedPath)
        End If
    End Sub

    Private Sub FileResult(ByVal fp As String, ByVal fn As String, ByVal fl As String, ByVal fc As String)
        Dim fSize As String = GetFileSize(CLng(fl))
        Me.lvFile.Items.Add(New ListViewItem(New String() {fp, fn, fc, fSize}))
        Me.tsslblResult.Text = String.Format("폴더 : {0} 개, 파일 : {1} 개", DirCount, FileCount)
    End Sub

    Private Function GetFileSize(ByVal byteCount As Double) As String
        Dim size As String = "0 Bytes"
        If byteCount >= 173741824.0 Then
            size = String.Format("{0:##.##}", byteCount / 1073741824.0) + " GB"
        ElseIf byteCount >= 1048576.0 Then
            size = String.Format("{0:##.##}", byteCount / 1048576.0) + " MB"
        ElseIf byteCount >= 1024.0 Then
            size = String.Format("{0:##.##}", byteCount / 1024.0) + " KB"
        ElseIf byteCount > 0 And byteCount < 1024.0 Then
            size = byteCount.ToString() + " Bytes"
        End If

        Return size
    End Function

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If threFileView IsNot Nothing Then threFileView.Abort()
    End Sub
End Class
