﻿Imports System.Drawing.Drawing2D

Public Class FlexibleForm
    Public Shared Sub CreateControlRegion(ByVal control As Control, ByVal bitmap As Bitmap, ByVal flag As Boolean)
        If control Is Nothing Or bitmap Is Nothing Then
            Return
        End If

        control.Width = bitmap.Width
        control.Height = bitmap.Height

        If flag Then
            Dim form As Form = control
            form.Width += 20
            form.Height += 80
            form.FormBorderStyle = FormBorderStyle.None
            form.BackgroundImage = bitmap
            Dim graphicsPath As GraphicsPath = CalculateControlGraphicsPath(bitmap)
            form.Region = New Region(graphicsPath)
        ElseIf Not flag Then
            Dim button As Button = control
            button.Text = ""
            button.Cursor = Cursors.Hand
            button.BackgroundImage = bitmap
            Dim graphicsPath As GraphicsPath = CalculateControlGraphicsPath(bitmap)
            button.Region = New Region(graphicsPath)
        End If
    End Sub

    Private Shared Function CalculateControlGraphicsPath(ByVal bitmap As Bitmap) As GraphicsPath
        Dim graphicsPath As GraphicsPath = New GraphicsPath()
        Dim colorTransparent As Color = bitmap.GetPixel(0, 0)
        Dim colOpaquePixcel As Integer = 0
        For row As Integer = 0 To bitmap.Height - 1
            colOpaquePixcel = 0
            For col As Integer = 0 To bitmap.Width - 1
                colOpaquePixcel = col
                Dim colNext As Integer = col
                For colNext = colOpaquePixcel To bitmap.Width - 1
                    If bitmap.GetPixel(colNext, row) = colorTransparent Then
                        Exit For
                    End If
                Next
                graphicsPath.AddRectangle(New Rectangle(colOpaquePixcel, row, colNext - colOpaquePixcel, 1))
                col = colNext
            Next
        Next
        Return graphicsPath
    End Function
End Class
