﻿Public Class Form1
    Dim g As Graphics
    Dim gColor As Color
    Dim p As Pen
    Dim mouseX, mouseY As Integer
    Dim Drag = False

    Private Sub DrawGrid()
        g.DrawLine(p, 20, 20, plOmok.Size.Width - 20, 20)
        g.DrawLine(p, 20, plOmok.Size.Height - 20, plOmok.Size.Width - 20, plOmok.Size.Height - 20)
        g.DrawLine(p, 20, 20, 20, plOmok.Size.Height - 20)
        g.DrawLine(p, plOmok.Size.Width - 20, 20, plOmok.Size.Width - 20, plOmok.Size.Height - 20)

        For i As Integer = 40 To plOmok.Size.Width - 40 Step 20
            g.DrawLine(New Pen(gColor), i, 20, i, plOmok.Height - 20)
        Next
        For i As Integer = 40 To plOmok.Size.Height - 40 Step 20
            g.DrawLine(New Pen(gColor), 20, i, plOmok.Width - 20, i)
        Next
    End Sub

    Private Sub plOmok_Paint(sender As Object, e As PaintEventArgs) Handles plOmok.Paint
        DrawGrid()
    End Sub

    Public Sub New()
        InitializeComponent()
        g = plOmok.CreateGraphics()
        gColor = Color.Black
        p = New Pen(gColor)
        p.Width = 2
    End Sub

    Private Sub tsMenu_ItemClicked(sender As Object, e As ToolStripItemClickedEventArgs) Handles tsMenu.ItemClicked
        If Me.tsMenu.Items.Count > 0 Then
            Dim myPic As PictureBox = New PictureBox()
            AddHandler myPic.MouseDown, AddressOf MyMouseClick
            AddHandler myPic.MouseMove, AddressOf MyMouseMove
            AddHandler myPic.MouseUp, AddressOf MyMouseUp
            Me.plOmok.Controls.Add(myPic)
            myPic.Location = New Point(myPic.Location.X, myPic.Location.Y)
            myPic.BringToFront()
            myPic.BackgroundImageLayout = ImageLayout.Stretch

            Dim tagId As Integer = Convert.ToInt32(e.ClickedItem.Tag)
            myPic.BackgroundImage = tsMenu.Items(tagId).Image
            myPic.Name = tsMenu.Items(tagId).ToolTipText
            myPic.Tag = tsMenu.Items(tagId).Tag
            myPic.Size = New System.Drawing.Size(15, 15)
            myPic.Invalidate()
        End If
    End Sub

    Private Sub MyMouseClick(sender As Object, e As MouseEventArgs)
        Dim Pic As PictureBox = CType(sender, PictureBox)
        If e.Button = MouseButtons.Left Then
            mouseX = -e.X
            mouseY = -e.Y
            Drag = True
            Pic.Invalidate()
        End If
    End Sub

    Private Sub MyMouseMove(sender As Object, e As MouseEventArgs)
        Dim Pic As PictureBox = CType(sender, PictureBox)
        If Drag Then
            Dim mPoint As Point = New Point()
            mPoint = Me.plOmok.PointToClient(MousePosition)
            mPoint.Offset(mouseX, mouseY)
            Pic.Location = mPoint
        End If
    End Sub

    Private Sub MyMouseUp(sender As Object, e As MouseEventArgs)
        Dim Pic As PictureBox = CType(sender, PictureBox)
        If Drag Then
            Drag = False
            Pic.Invalidate()
        End If
    End Sub
End Class
