﻿Imports System.IO '파일 클래스 사용
Imports ICSharpCode.SharpZipLib.Zip '압축 클래스 기능 사용

Public Class Form1
    Dim NewZipFileName As String = "" '새로 압축할 파일 명
    Private Sub btnPath_Click(sender As Object, e As EventArgs) Handles btnPath.Click
        Dim folderDialog As FolderBrowserDialog = New FolderBrowserDialog()
        If folderDialog.ShowDialog() = DialogResult.OK Then
            Me.txtPath.Text = folderDialog.SelectedPath
            ListFiles()
        End If
    End Sub
    Private Sub ListFiles()
        Try
            lvZipFile.Items.Clear() 'lvZipFile.Items 클리어
            Dim strDir = Me.txtPath.Text '압축 폴더 경로 저장
            If strDir = "" Or Not Directory.Exists(strDir) Then Return '폴더 경로 유효성 검사

            Dim TmpDir = ""
            Dim files As String() = Directory.GetFiles(strDir, "*.*", System.IO.SearchOption.AllDirectories)
            For Each file As String In files
                Dim fi As FileInfo = New FileInfo(file)

                TmpDir = Path.GetDirectoryName(fi.FullName).Replace(strDir, "")
                Me.lvZipFile.Items.Add(New ListViewItem(New String() {fi.Name, TmpDir, String.Format("{0:N0}", fi.Length.ToString())}))
            Next
        Catch
        End Try
    End Sub

    Private Sub btnZipPath_Click(sender As Object, e As EventArgs) Handles btnZipPath.Click
        If Me.fbdFolder.ShowDialog() = DialogResult.OK Then '[폴더 찾아보기] 대화상자 호출
            Me.txtZipPath.Text = fbdFolder.SelectedPath '지정된 폴더 경로 설정
        End If
    End Sub

    Private Sub btnZip_Click(sender As Object, e As EventArgs) Handles btnZip.Click
        If Me.txtPath.Text = "" Then
            MessageBox.Show("압축할 파일의 대상경로가 지정되지 않았습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtPath.Focus()
            Return
        End If
        If Me.txtZipPath.Text = "" Then
            MessageBox.Show("압축파일 저장경로가 지정되지 않았습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtZipPath.Focus()
            Return
        End If
        If Me.txtZipName.Text = "" Then
            MessageBox.Show("압축명을 입력하세요", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtZipName.Focus()
        Else
            NewZipFileName = Me.txtZipName.Text
            If FileNameCheck(Me.txtZipPath.Text & "\" & Me.txtZipName.Text) Then
                FileCompress()
            End If
        End If
    End Sub

    Private Function FileNameCheck(ByVal fiPath As String) As Boolean
        Dim i As Integer = 1
        If File.Exists(fiPath) Then
            Dim dlr = MessageBox.Show("이미 압축할 동일한 파일이 존재합니다." & vbNewLine &
                                      "파일명을 수정하시려면 Yes를 누르시고" & vbNewLine & "파일을 삭제하고 생성하려면 No를 누르세요",
                                      "알림", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Information)
            If dlr = DialogResult.Yes Then
                Dim NewfiPath As String = ""
                Do
                    NewfiPath = String.Format("{0}\{1}({2}).zip", Path.GetDirectoryName(fiPath), Path.GetFileNameWithoutExtension(fiPath), i)
                    i = i + 1
                Loop While (File.Exists(NewfiPath))
                NewZipFileName = Path.GetFileName(NewfiPath)
                Return True
            ElseIf dlr = DialogResult.No Then
                If File.Exists(fiPath) Then File.Delete(fiPath)
                Return True
            Else
                Return False
            End If
        End If
        Return True
    End Function

    Private Sub FileCompress()
        Dim strOrgDir = Me.txtPath.Text '압축할 폴더
        Dim strDir = Me.txtZipPath.Text '압축파일 저장 폴더
        Dim FileListCnt = Me.lvZipFile.Items.Count() '압축할 파일 및 폴더 개수
        If FileListCnt <= 0 Then Return '압축할 파일 및 폴더가 없으면 메서드 종료

        Dim strDestPathFile = strDir & "\" & NewZipFileName '새로운 압축 파일 경로

        Me.ProgressBarZip.Visible = True 'ProgressBarZip 컨트롤 초기화
        Me.ProgressBarZip.Value = 0 'ProgressBarZip 컨트롤 초기화
        Me.ProgressBarZip.Minimum = 0 'ProgressBarZip 컨트롤 초기화
        Me.ProgressBarZip.Maximum = FileListCnt 'ProgressBarZip 컨트롤 초기화

        Try
            Cursor = Cursors.WaitCursor
            Using s As ZipOutputStream = New ZipOutputStream(File.Create(strDestPathFile))

                s.SetLevel(9) '압축률 0~9
                s.Password = Me.txtZipPwd.Text

                Dim buffer(4096) As Byte
                Dim strOrgFile = ""
                Dim strOrgPathFile = ""
                Dim strOrgPath = ""

                For i As Integer = 0 To FileListCnt - 1
                    strOrgFile = Me.lvZipFile.Items(i).Text
                    strOrgPath = Me.lvZipFile.Items(i).SubItems(1).Text

                    If strOrgPath = "" Then
                        strOrgPathFile = strOrgDir & "\" & strOrgFile
                    Else
                        strOrgPathFile = strOrgDir & strOrgPath & "\" & strOrgFile
                    End If

                    Dim entry As ZipEntry = New ZipEntry(Path.GetFileName(strOrgPathFile))

                    entry.Comment = strOrgPath '폴더생성
                    s.PutNextEntry(entry)


                    Using fs As FileStream = File.OpenRead(strOrgPathFile)
                        Dim sourceBytes As Integer
                        Do
                            sourceBytes = fs.Read(buffer, 0, buffer.Length)
                            s.Write(buffer, 0, sourceBytes)
                        Loop While (sourceBytes > 0)
                    End Using

                    Me.ProgressBarZip.Value = i + 1
                Next i
                s.Finish()
                s.Close()

                Cursor = Cursors.Default '기본 커서 설정

                MessageBox.Show("정상적으로 압축을 하였습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.ProgressBarZip.Visible = False '진행바 숨김
            End Using
        Catch
            Cursor = Cursors.Default '기본 커서 설정
            Me.ProgressBarZip.Visible = False '진행바 숨김
            MessageBox.Show("압축과정에서 오류가 발생하였습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnUnPath_Click(sender As Object, e As EventArgs) Handles btnUnPath.Click
        If Me.ofdFile.ShowDialog() = DialogResult.OK Then '압축 풀기 파일 선택
            Me.txtUnPath.Text = ofdFile.FileName '압축 풀기 파일 경로 설정
        End If
    End Sub

    Private Sub btnUnZipPath_Click(sender As Object, e As EventArgs) Handles btnUnZipPath.Click
        If Me.fbdFolder.ShowDialog() = DialogResult.OK Then '압축 풀기 폴더 선택
            Me.txtUnZipPath.Text = Me.fbdFolder.SelectedPath '압축 풀기 폴더 경로 설정
        End If
    End Sub

    Private Sub btnUnZip_Click(sender As Object, e As EventArgs) Handles btnUnZip.Click
        If Me.txtUnPath.Text = "" Then
            MessageBox.Show("압축풀기 파일 대상경로가 지정되지 않았습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtUnPath.Focus()
            Return
        End If
        If Me.txtUnZipPath.Text = "" Then
            MessageBox.Show("압축풀기 저장경로가 지정되지 않았습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtUnZipPath.Focus()
            Return
        End If
        FileUnCompress()
    End Sub
    Private Sub FileUnCompress()
        Me.lvUnZipFile.Items.Clear() 'lvUnZipFile 컨트롤의 Items 클리어
        Me.ProgressBarUnZip.Visible = True 'ProgressBarUnZip 초기화
        Me.ProgressBarUnZip.Value = 0 'ProgressBarUnZip 초기화
        Me.ProgressBarUnZip.Minimum = 0 'ProgressBarUnZip 초기화

        Dim strUnZipDir As String = "" '압축 풀 폴더 경로 저장 변수
        Try
            Dim FList As New List(Of String)()
            Using zFile As ZipFile = New ZipFile(txtUnPath.Text)
                For Each e As ZipEntry In zFile
                    If e.IsFile Then
                        FList.Add(e.Comment)
                    End If
                Next
            End Using
            Dim TotCnt As Integer = FList.Count
            Me.ProgressBarUnZip.Maximum = TotCnt
            Dim FNum As Integer = 0
            Using s As ZipInputStream = New ZipInputStream(File.OpenRead(txtUnPath.Text))
                s.Password = Me.txtUnZipPwd.Text
                Dim i As Integer = 0
                Dim theEntry As ZipEntry = s.GetNextEntry()
                While Not theEntry Is Nothing
                    Dim fileName As String = theEntry.Name
                    Dim FolderName As String = FList(FNum)
                    strUnZipDir = Me.txtUnZipPath.Text

                    If Not FolderName Is Nothing Then
                        If FolderName.Length > 0 Then
                            strUnZipDir = Me.txtUnZipPath.Text + FolderName
                            Dim di As DirectoryInfo = New DirectoryInfo(strUnZipDir)
                            If Not di.Exists Then
                                Directory.CreateDirectory(strUnZipDir)
                            End If
                            di = Nothing
                        End If
                    End If


                    If fileName <> "" Then
                        Dim struz As String = strUnZipDir & "\" & fileName
                        Me.lvUnZipFile.Items.Add(fileName)

                        Using streamWriter As FileStream = File.Create(struz)
                            Dim Size As Integer = 4096
                            Dim UnZipData(4096) As Byte
                            While True
                                Size = s.Read(UnZipData, 0, UnZipData.Length)
                                If Size > 0 Then
                                    streamWriter.Write(UnZipData, 0, Size)
                                Else
                                    Exit While
                                End If
                            End While
                        End Using

                        Dim fi As FileInfo = New FileInfo(struz)
                        If FList(FNum) = "" Then
                            Me.lvUnZipFile.Items(i).SubItems.Add("")
                        Else
                            Me.lvUnZipFile.Items(i).SubItems.Add(FList(FNum))
                        End If
                        Me.lvUnZipFile.Items(i).SubItems.Add(String.Format("{0:N0}", fi.Length))

                    End If

                    i = i + 1
                    FNum = FNum + 1
                    Me.ProgressBarUnZip.Value = FNum
                    theEntry = s.GetNextEntry()
                End While
                s.Close()
            End Using
            Cursor = Cursors.Default '커서 기본 설정
            Dim dlr = MessageBox.Show("압축풀기가 정상적으로 완료되었습니다." & vbNewLine & "압축이 풀린 디렉터리를 열려면 Yes를 누르세요.",
                                      "알림", MessageBoxButtons.YesNo, MessageBoxIcon.Information)
            Me.ProgressBarUnZip.Visible = False 'ProgressBarUnZip 숨김
            If dlr = Windows.Forms.DialogResult.Yes Then
                Dim myprocess = New Process()
                myprocess.StartInfo.FileName = Me.txtUnZipPath.Text
                myprocess.Start()
            Else
                Return
            End If
        Catch
            Cursor = Cursors.Default '커서 기본 설정
            Me.ProgressBarUnZip.Visible = False 'ProgressBarUnZip 숨김
            MessageBox.Show("압축풀기 중 오류가 발생하였습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
End Class
