﻿Imports System.IO

Public Class Form1

    Private strCurPos = ""  '재생 시간(시점)
    Private strMP3Title = ""  'MP3 제목
    Private strMP3FilePath = ""  'MP3 파일 경로
    Private strMP3FileName = ""  'MP3 파일 이름
    Private strMP3Length = ""  'MP3 재생 길이
    Private intCurListPos = 0  'MP3 재생 리스트 인덱스 번호
    Dim Mp3 As MP3Play = New MP3Play()  'MP3Play 클래스 개체
    Dim MusicNamePath As New List(Of String)  'MP3 파일 경로 저장 List 클래스 개체

    Private Sub btnFileOpen_Click(sender As Object, e As EventArgs) Handles btnFileOpen.Click
        If Me.ofdMp3File.ShowDialog() = DialogResult.OK Then
            strMP3FilePath = ofdMp3File.FileName
            strMP3FileName = Path.GetFileName(ofdMp3File.FileName)
            strMP3Length = Mp3.OpenFile(strMP3FilePath)
            AddFileList(strMP3FileName, strMP3FilePath, strMP3Length)
        End If
    End Sub

    Private Sub AddFileList(strMP3FileName As String, strMP3FilePath As String, strMP3Length As String)
        Dim strCount = (lvMp3List.Items.Count + 1).ToString()
        Dim Musicinfo = New String(2) {strCount, strMP3FileName, strMP3Length}
        MusicNamePath.Add(strMP3FilePath)
        lvMp3List.Items.Add(New ListViewItem(Musicinfo))
    End Sub

    Private Sub btnPlay_Click(sender As Object, e As EventArgs) Handles btnPlay.Click
        If lvMp3List.Items.Count = 0 Then Return
        If Me.lvMp3List.SelectedItems.Count = 0 Then
            intCurListPos = 0
        End If
        If Mp3.playStatus = Player_Status.Paused Then
            Dim trackCurPosition As Double
            trackCurPosition = Convert.ToDouble(Me.PlayBar.Value / Convert.ToDouble(PlayBar.Maximum)) * Mp3.Get_TotalDuration()
            strMP3FilePath = MusicNamePath.Item(intCurListPos)
            Mp3.Play(strMP3FilePath, trackCurPosition)
        ElseIf Mp3.playStatus = Player_Status.Stopped Or Mp3.playStatus = Player_Status.None Then
            strMP3FilePath = MusicNamePath.Item(intCurListPos)
            Mp3.Play(strMP3FilePath, 0)
        Else
            Return
        End If
        Me.lblPlayResult.Text = "재   생"
    End Sub

    Private Sub btnStop_Click(sender As Object, e As EventArgs) Handles btnStop.Click
        If lvMp3List.Items.Count = 0 Then Return
        Mp3.PlayStop()
        Me.PlayBar.Value = 0
        Me.lblPlayResult.Text = "정   지"
    End Sub

    Private Sub btnPause_Click(sender As Object, e As EventArgs) Handles btnPause.Click
        If lvMp3List.Items.Count = 0 Then Return
        Mp3.PlayPause()
        Me.lblPlayResult.Text = "일시정지"
    End Sub

    Private Sub lvMp3List_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lvMp3List.SelectedIndexChanged
        If Me.lvMp3List.SelectedItems.Count > 0 Then
            intCurListPos = Me.lvMp3List.SelectedItems(0).Index
        End If
    End Sub

    Private Sub lvMp3List_DoubleClick(sender As Object, e As EventArgs) Handles lvMp3List.DoubleClick
        Mp3.PlayStop()
        If Me.lvMp3List.SelectedItems.Count > 0 Then
            intCurListPos = Me.lvMp3List.SelectedItems(0).Index
            btnPlay_Click(sender, e)
        End If
    End Sub

    Private Sub Timer_Tick(sender As Object, e As EventArgs) Handles Timer.Tick
        If Mp3.playStatus = Player_Status.Running Then
            If Me.PlayBar.Value > PlayBar.Maximum - 1 Then
                intCurListPos = intCurListPos + 1
                If intCurListPos >= lvMp3List.Items.Count Then intCurListPos = 0
                lvMp3List.Items(intCurListPos).Selected = True
                Mp3.playStatus = Player_Status.None
                btnPlay_Click(sender, e)
                Mp3.Set_AudioVolume(-10000 + Me.VolumeBar.Value * 100)
                Mp3.Set_AudioBalance(-10000 + Me.BalanceBar.Value * 200)
            End If
            TrackBarRun()
        End If
    End Sub

    Public Sub TrackBarRun()
        strCurPos = String.Format("{0}/{1}",
                                    Mp3.Convert_Position_To_Time(Convert.ToInt32(Mp3.Get_CurPosition())),
                                    Mp3.Convert_Position_To_Time(Convert.ToInt32(Mp3.Get_TotalDuration())))
        Me.lblCurPos.Text = strCurPos
        PlayBar.Value = Convert.ToInt32((Mp3.Get_CurPosition() * PlayBar.Maximum / Mp3.Get_TotalDuration()))
    End Sub

    Private Sub PlayBar_Scroll(sender As Object, e As EventArgs) Handles PlayBar.Scroll
        Dim trackCurPosition As Double
        trackCurPosition = Convert.ToDouble(Me.PlayBar.Value / Convert.ToDouble(PlayBar.Maximum)) * Mp3.Get_TotalDuration()
        Mp3.Set_CurPosition(trackCurPosition)
    End Sub

    Private Sub VolumeBar_Scroll(sender As Object, e As EventArgs) Handles VolumeBar.Scroll
        If Mp3.playStatus = Player_Status.Running Then
            Mp3.Set_AudioVolume(-10000 + Me.VolumeBar.Value * 100)
        End If
    End Sub

    Private Sub BalanceBar_Scroll(sender As Object, e As EventArgs) Handles BalanceBar.Scroll
        If Mp3.playStatus = Player_Status.Running Then
            Mp3.Set_AudioBalance(-10000 + Me.BalanceBar.Value * 200)
            If (-10000 + Me.BalanceBar.Value * 200) < 0 Then
                Me.lblBalance.Text = "Left : " & CInt(-10000 + Me.BalanceBar.Value * 200) / 100
            ElseIf (-10000 + Me.BalanceBar.Value * 200) = 0 Then
                Me.lblBalance.Text = "L = R "
            ElseIf (-10000 + Me.BalanceBar.Value * 200) > 0 Then
                Me.lblBalance.Text = "Right " & CInt(-10000 + Me.BalanceBar.Value * 200) / 100
            End If
        End If
    End Sub
End Class
