﻿Imports System.IO '파일 클래스 사용
Imports System.Runtime.Serialization.Formatters.Binary 'serialize 및 deserialize 사용
Imports Microsoft.Win32 '레지스트리 사용

Public Class Form1
    Dim SizeY As Integer = 300 '세로 사이즈
    Dim COCheck As Boolean = True '열고 숨기기 메뉴 체크
    Dim FormReSize = True

    Dim ptMouseCurrentPos As Point  '마우스 클릭 좌표 지정
    Dim ptMouseNewPos As Point  '이동시 마우스 좌표
    Dim ptFormCurrentPos As Point  '폼 위치 좌표 지정
    Dim ptFormNewPos As Point  '이동시 폼 위치 좌표
    Dim bFormMouseDown As Boolean = False

    Dim regKey As RegistryKey = Registry.CurrentUser '레지스트리 기본 키 값 엑세스

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            regKey = regKey.CreateSubKey("Software\\Microsoft\\Windows\\CurrentVersion\\Run")
            If Not regKey.GetValue("Memo").ToString() Is Nothing Then
                Me.자동실행ToolStripMenuItem.Checked = True
            End If
        Catch
        End Try
        DataView() '데이터 출력 함수 호출
        FormShow() 'Form1 Loaction 맞춤
    End Sub
    Private Sub DataView()
        Try
            Dim addresses As Hashtable = Nothing
            Dim fs As New FileStream("Memo.dat", FileMode.Open)
            Dim formatter As New BinaryFormatter
            addresses = DirectCast(formatter.Deserialize(fs), Hashtable)

            For Each de As DictionaryEntry In addresses
                If de.Key.ToString() <> "" Then
                    Me.rtbMemo.AppendText(de.Key.ToString())
                    Me.rtbMemo.AppendText(vbNewLine)
                    Me.rtbMemo.AppendText(de.Value.ToString())
                End If
            Next
            fs.Close()
        Catch
        End Try
    End Sub
    Private Sub FormShow()
        Dim f As FileInfo = New FileInfo(Application.StartupPath & "\sys.ini")
        If f.Exists <> True Then
            Dim fullScreen As System.Drawing.Rectangle = System.Windows.Forms.Screen.PrimaryScreen.Bounds
            Me.Location = New System.Drawing.Point(fullScreen.Width - 300, 0)
            SysFileSave()
        Else
            Dim sr As StreamReader = New StreamReader(Application.StartupPath & "\sys.ini")
            Dim LocationXY = sr.ReadLine().Split(New Char() {"="})(1).ToString().Split(New Char() {","})
            Me.Location = New Point(Convert.ToInt32(LocationXY(0)), Convert.ToInt32(LocationXY(1)))
            sr.Close()
        End If
    End Sub
    Private Sub SysFileSave()
        Dim sw As StreamWriter = File.CreateText(Application.StartupPath & "\sys.ini")
        sw.WriteLine("FormLocation=" & Me.Location.X & "," & Me.Location.Y)
        sw.Close()
    End Sub
    Private Sub 종료ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 종료ToolStripMenuItem.Click
        FormClose()
    End Sub

    Private Sub FormClose()
        Dim dlr = MessageBox.Show("저장된 데이터 및 설정을 초기화 합니다.", "알림", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
        If dlr = DialogResult.Yes Then
            If File.Exists("Memo.dat") Then
                File.Delete("Memo.dat")
            End If
            If File.Exists("Sys.ini") Then
                File.Delete("Sys.ini")
            End If
            Me.Close()
        Else
            Me.Close()
        End If
    End Sub

    Private Sub SaveData(ByVal StrDate As String)
        Dim addresses As Hashtable = New Hashtable()
        addresses.Add(StrDate, Me.rtbMemo.Text)
        Dim fs As FileStream = New FileStream("Memo.dat", FileMode.Create)
        Dim formatter As BinaryFormatter = New BinaryFormatter()
        formatter.Serialize(fs, addresses)
        fs.Close()
    End Sub

    Private Sub tClose_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tClose.Tick
        If SizeY > 25 Then 'Form1 사이즈를 줄임
            SizeY -= 5 'Form1 사이즈를 ’-5‘씩 줄임
            Me.Size = New System.Drawing.Point(300, SizeY) 'Form1 사이즈를 설정
        Else
            Me.tClose.Enabled = False
        End If
    End Sub

    Private Sub tOpen_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tOpen.Tick
        If SizeY <= 300 Then 'Form1 사이즈를 늘림
            SizeY += 10 'Form1 사이즈를 ’10‘씩 늘림
            Me.Size = New System.Drawing.Point(300, SizeY) 'Form1 사이즈를 설정
        Else
            Me.tOpen.Enabled = False
        End If
    End Sub

    Private Sub 자동실행ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 자동실행ToolStripMenuItem.Click
        Dim regKey As RegistryKey = Registry.CurrentUser
        regKey = regKey.CreateSubKey("Software\\Microsoft\\Windows\\CurrentVersion\\Run")
        Dim keyExist As Boolean = False

        For Each str As String In regKey.GetValueNames()
            If str = "Memo" Then keyExist = True
        Next

        If Not Me.자동실행ToolStripMenuItem.Checked Then
            If Not keyExist Then
                Dim path As String = Directory.GetCurrentDirectory() + "\mook_Memo.exe"
                regKey.SetValue("Memo", path)
            End If
            Me.자동실행ToolStripMenuItem.Checked = True
        Else
            If keyExist Then regKey.DeleteValue("Memo")
            Me.자동실행ToolStripMenuItem.Checked = False
        End If
    End Sub

    Private Sub tsbtnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbtnClose.Click
        FormClose() '폼 종료 메서드 호출
    End Sub

    Private Sub 메모저장ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 메모저장ToolStripMenuItem.Click
        SaveData(String.Format("{0}월 {1}일 메모", DateTime.Now.Month.ToString(), DateTime.Now.Day.ToString()) & vbNewLine)
    End Sub

    Private Sub 메모숨김ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 메모숨김ToolStripMenuItem.Click
        If COCheck = True Then
            Me.tClose.Enabled = True
            Me.메모숨김ToolStripMenuItem.Text = "메모열기"
            COCheck = False
        Else
            Me.tOpen.Enabled = True
            Me.메모숨김ToolStripMenuItem.Text = "메모숨김"
            COCheck = True
        End If
    End Sub

    Private Sub tsBar_DoubleClick(sender As Object, e As EventArgs) Handles tsBar.DoubleClick
        If FormReSize = True Then
            Me.Size = New System.Drawing.Size(60, 25)
            FormReSize = False '폼 최소화’
        Else
            Me.Size = New System.Drawing.Size(300, 300)
            FormReSize = True '폼 최대화’
        End If
    End Sub

    Private Sub tsBar_MouseDown(sender As Object, e As MouseEventArgs) Handles tsBar.MouseDown
        If e.Button = MouseButtons.Left Then
            bFormMouseDown = True '왼쪽 마우스 클릭 체크
            ptMouseCurrentPos = Control.MousePosition '마우스 클릭 좌표
            ptFormCurrentPos = Me.Location '폼의 위치 좌표
        End If
    End Sub

    Private Sub tsBar_MouseUp(sender As Object, e As MouseEventArgs) Handles tsBar.MouseUp
        bFormMouseDown = False '왼쪽 마우스 클릭 해체 체크
        SysFileSave()
    End Sub

    Private Sub tsBar_MouseMove(sender As Object, e As MouseEventArgs) Handles tsBar.MouseMove
        If bFormMouseDown = True Then '왼쪽 마우스 클릭시
            ptMouseNewPos = Control.MousePosition
            ptFormNewPos.X = ptMouseNewPos.X - ptMouseCurrentPos.X + ptFormCurrentPos.X '마우스 이동시 가로 좌표
            ptFormNewPos.Y = ptMouseNewPos.Y - ptMouseCurrentPos.Y + ptFormCurrentPos.Y '마우스 이동시 세로 좌표
            Me.Location = ptFormNewPos
            ptFormCurrentPos = ptFormNewPos
            ptMouseCurrentPos = ptMouseNewPos
        End If
    End Sub
End Class
