﻿Imports System.Threading '스레드 개체 생성
Public Class Form1
    Dim oCPU As PerformanceCounter = New PerformanceCounter("Processor", "% Processor Time", "_Total") '시스템 CPU 성능 카운터
    Dim oMem As PerformanceCounter = New PerformanceCounter("Memory", "% Committed Bytes In Use") '시스템 Mem 성능 카운터
    Dim pCPU As PerformanceCounter = New PerformanceCounter() '프로세스 CPU 성능 카운터
    Dim bExit As Boolean = False '실시간 체크를 위한 While 조건
    Dim cp As Integer = 0
    Dim checkThread As Thread  '스레드 개체 생성
    Dim ProcessCheckThread As Thread  '스레드 개체 생성
    Delegate Sub OnProcDelegate(ByVal lvt As List(Of String()), ByVal cp As String) 'lvView 입력 델리게이트
    Dim OnProc As OnProcDelegate = Nothing
    Delegate Sub OnCPUMEMDelegate(ByVal c As String, ByVal m As String) 'tsslCpu, tsslMem 입력 델리게이트
    Dim OnCPUMEM As OnCPUMEMDelegate = Nothing
    Dim ProcList As List(Of String()) = New List(Of String())() 'Process 정보 리스트

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        OnProc = New OnProcDelegate(AddressOf OnProcRun) '델리게이트 초기화
        OnCPUMEM = New OnCPUMEMDelegate(AddressOf OnCPUMEMRun) '델리게이트 초기화
        ProcessView()
        checkThread = New Thread(AddressOf getCPU_Info)
        checkThread.Start() 'checkThread 스레드 프로세스 시작
        ProcessCheckThread = New Thread(AddressOf getProcessMem_Info)
        ProcessCheckThread.Start() 'ProcessCheckThread 스레드 프로세스 시작
    End Sub

    Private Sub OnProcRun(ByVal arr As List(Of String()), ByVal cp As String)
        Me.lvView.Items.Clear()
        For Each strarr As String() In arr
            Me.lvView.Items.Add(New ListViewItem(strarr))
        Next
        Me.tsslProcess.Text = "프로세스 : " & cp & "개"
    End Sub

    Private Sub OnCPUMEMRun(ByVal c As String, ByVal m As String)
        Me.tsslCpu.Text = String.Format("CPU 사용: {0} %", c)
        Me.tsslMem.Text = String.Format("실제 메모리 : {0} %", m)
    End Sub

    Private Sub ProcessView()
        cp = 0
        ProcList.Clear()
        For Each proc In Process.GetProcesses()
            pCPU = New PerformanceCounter("Process", "% Processor Time", proc.ProcessName)
            Dim str As String()
            Try
                str = proc.TotalProcessorTime.ToString().Split(".")
            Catch ex As Exception
                str = New String() {""}
            End Try
            ProcList.Add(New String() {proc.ProcessName.ToString(), proc.Id.ToString(), str(0),
                                         (proc.WorkingSet64 / 1024).ToString("#,#") + " KB"})
            cp = cp + 1
        Next
        Invoke(OnProc, ProcList, cp.ToString())
    End Sub

    Private Sub getCPU_Info()
        While Not bExit
            Invoke(OnCPUMEM, oCPU.NextValue().ToString(), oMem.NextValue().ToString())
            Thread.Sleep(1000)
        End While
    End Sub

    Private Sub getProcessMem_Info()
        While Not bExit
            Thread.Sleep(500)
            If Not cp = Process.GetProcesses.Length Then
                ProcessView()
            End If
        End While
    End Sub

    Private Sub btnKill_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnKill.Click
        Try
            If Me.lvView.SelectedItems.Count > 0 Then
                Dim PName = Me.lvView.SelectedItems(0).SubItems(0).Text
                Dim tProcess = Process.GetProcessesByName(PName)
                If tProcess.Length = 1 Then
                    Dim dlr = MessageBox.Show(PName + " 프로세스를 끝내시겠습니까?", "알림",
                                              MessageBoxButtons.YesNo, MessageBoxIcon.Warning)
                    If dlr = DialogResult.Yes Then
                        tProcess(0).Kill()
                        ProcessView()
                    End If
                Else
                    MessageBox.Show(Me.lvView.SelectedItems(0).SubItems(0).Text +
                                    "프로세스는 존재하지 않습니다", "알림", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    ProcessView()
                End If
            End If
        Catch
            Return
        End Try
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If Not checkThread Is Nothing Then
            Me.Dispose()
            checkThread.Abort() 'checkThread 외부 스레드 강제 종료
        End If
        If Not ProcessCheckThread Is Nothing Then
            Me.Dispose()
            ProcessCheckThread.Abort() 'ProcessCheckThread 외부 스레드 강제 종료
        End If
        Application.Exit() '어플리케이션 종료
    End Sub
End Class
