﻿Imports System.IO
Imports System.Threading
Imports System.Text

Public Class Form1

    Private Structure NETRESOURCE
        Public dwScope As UInt32
        Public dwType As UInt32
        Public dwDisplayType As UInt32
        Public dwUsage As UInt32
        Public lpLocalName As String
        Public lpRemoteName As String
        Public lpComment As String
        Public lpProvider As String
    End Structure

    Private Declare Function WNetUseConnection Lib "mpr.dll" _
        Alias "WNetUseConnectionA" (
        ByVal hwndOwner As IntPtr,
        ByRef lpNetResource As NETRESOURCE,
        ByVal lpPassword As String,
        ByVal lpUsername As String,
        ByVal dwFlags As UInt32,
        ByVal lpAccessName As StringBuilder,
        ByRef lpBufferSize As IntPtr,
        ByRef lpResult As IntPtr) _
   As UInt32

    Declare Function WNetCancelConnection2 Lib "mpr.dll" Alias "WNetCancelConnection2A" (ByVal lpName As String, ByVal dwFlags As Int32, ByVal fForce As Int32) As Long

    Public Const CONNECT_UPDATE_PROFILE = &H1

    Private Declare Function InternetGetConnectedState Lib "wininet.dll" _
            (ByRef lpdwFlags As Long, ByVal dwReserved As Int32) As Boolean

    Private Enum ConnectionStates
        Modem = &H1
        LAN = &H2
        Proxy = &H4
        RasInstalled = &H10
        Offline = &H20
        Configured = &H40
    End Enum

    Dim ConnThre As Thread = Nothing
    Private Delegate Sub OnConnDelegate(ByVal Flag As Boolean)
    Private OnConn As OnConnDelegate = Nothing

    Dim FileThre As Thread = Nothing
    Private Delegate Sub OnFileDelegate(ByVal fn As String, ByVal fd As String, ByVal ft As String, ByVal fs As Double)
    Private OnFile As OnFileDelegate = Nothing

    Dim NetDrive As String = String.Empty
    Dim NDrive As String = String.Empty
    Dim UserID As String = String.Empty
    Dim UserPwd As String = String.Empty
    Dim Drive As String = String.Empty

    Private Sub btnConnector_Click(sender As Object, e As EventArgs) Handles btnConnector.Click
        NDrive = Me.txtNDrive.Text
        UserID = Me.txtUserID.Text
        UserPwd = Me.txtUserPwd.Text
        Drive = Me.txtDrive.Text
        NetDrive = Drive & "\"

        ConnThre = New Thread(AddressOf NetDriveCheck)
        ConnThre.Start()
    End Sub

    Private Sub NetDriveCheck()
        Dim capcity As Integer = 64
        Dim resultFlags As UInteger = 0
        Dim flags As UInteger = 0

        Dim strRemoteConnectString As String = NDrive
        Dim strRemoteUserID As String = UserID
        Dim strRemotePWD As String = UserPwd

        Dim buffer As New StringBuilder(capcity)


        Dim ns As NETRESOURCE = New NETRESOURCE()

        ns.dwType = 1
        ns.lpLocalName = Drive
        ns.lpRemoteName = strRemoteConnectString
        ns.lpProvider = vbNullString
        Dim result As Integer = 100
        While True
            result = WNetUseConnection(0, ns, strRemotePWD, strRemoteUserID, flags, buffer, capcity, resultFlags)
            If result = 0 Then Exit While
            Thread.Sleep(100)
        End While
        Invoke(OnConn, True)
        ConnThre.Abort()
    End Sub

    Private Sub OnDelConn(ByVal Flag As Boolean)
        If Flag Then
            FileThre = New Thread(AddressOf FileList)
            FileThre.Start()
        Else
            MessageBox.Show("네트워크 드라이브 연결에 실패하였습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub FileList()
        Dim di As DirectoryInfo = New DirectoryInfo(NetDrive)
        For Each fs As FileInfo In di.GetFiles()
            Invoke(OnFile, fs.Name, fs.LastAccessTime.ToString(), fs.Extension, CType(fs.Length, Double))
        Next
        FileThre.Abort()
    End Sub

    Private Sub OnDelFile(ByVal fn As String, ByVal fd As String, ByVal ft As String, ByVal fs As Double)
        Dim FSize As String = GetFileSize(fs)
        Me.lvFile.Items.Add(New ListViewItem(New String() {fn, fd, ft, FSize}))
    End Sub

    Private Function GetFileSize(ByVal byteCount As Double) As String
        Dim Size As String = "0 Bytes"
        If byteCount >= 1073741824.0 Then
            Size = String.Format("{0:##.##}", byteCount / 1073741824.0) & " GB"
        ElseIf (byteCount >= 1048576.0) Then
            Size = String.Format("{0:##.##}", byteCount / 1048576.0) & " MB"
        ElseIf (byteCount >= 1024.0) Then
            Size = String.Format("{0:##.##}", byteCount / 1024.0) & " KB"
        ElseIf (byteCount > 0 And byteCount < 1024.0) Then
            Size = byteCount.ToString() & " Bytes"
        End If
        Return Size
    End Function

    Private Function IsConnected()
        Dim description As Integer
        Return InternetGetConnectedState(description, 0)
    End Function

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        OnConn = New OnConnDelegate(AddressOf OnDelConn)
        OnFile = New OnFileDelegate(AddressOf OnDelFile)

        While True
            If (IsConnected()) Then Exit While
            Thread.Sleep(1000)
        End While
    End Sub

    Private Sub btnDisConn_Click(sender As Object, e As EventArgs) Handles btnDisConn.Click
        Drive = Me.txtDrive.Text
        Try
            WNetCancelConnection2(Drive, CONNECT_UPDATE_PROFILE, 0)
        Catch ex As Exception
            Return
        End Try
        Me.lvFile.Items.Clear()
        MessageBox.Show("네트워크 드라이브가 정상적으로 끊어졌습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub
End Class
