﻿Imports System.IO
Imports System.Threading
Imports System.Net
Imports System.Net.Sockets
Imports System.Runtime.Serialization.Formatters.Binary

Public Class Form1
    Private ip As IPAddress = Nothing '아이피 주소
    Private port As Integer = 63000 '포트
    Private filename As String = String.Empty '파일 이름
    Private FilePath As String = String.Empty '파일 경로

    Private client As TcpClient 'TCP 클라이언트
    Private fs As FileStream '파일 스트림 개체
    Private myRead As StreamReader '스트림 읽기
    Private myReader As Thread '스레드 
    Private ns As NetworkStream '네트워크 스트림 개체

    Private FileSendThre As Thread = Nothing '파일 보내는 스레드

    Private Delegate Sub OnMessageDelegate(ByVal s As String)
    Private OnMsg As OnMessageDelegate = Nothing '델리게이트 선언

    Private Delegate Sub OnCountDelegate(ByVal i As Integer)
    Private OnCount As OnCountDelegate = Nothing '델리게이트 선언

    Private FileList As List(Of String) = New List(Of String)() '파일 리스트

    Private Flag As Boolean = True '파일 보낼때 스레드 일시정지
    Private Count As Integer = 0 '파일 개수 카운트

    Private Sub btnPath_Click(sender As Object, e As EventArgs) Handles btnPath.Click
        FileList.Clear()
        Me.lbFileList.Items.Clear()
        If Me.fbdFolder.ShowDialog() = DialogResult.OK Then
            FilePath = Me.fbdFolder.SelectedPath & "\"
            Dim di As DirectoryInfo = New DirectoryInfo(FilePath)
            For Each fi As FileInfo In di.GetFiles()
                Me.lbFileList.Items.Add(fi.FullName)
                FileList.Add(fi.FullName)
                Count += 1
            Next
        End If
        Me.tspgrBar.Maximum = Count
    End Sub

    Private Sub btnSend_Click(sender As Object, e As EventArgs) Handles btnSend.Click
        ip = IPAddress.Parse(Me.txtIp.Text)
        FileSendThre = New Thread(AddressOf FileSendThreRun)
        FileSendThre.Start()
    End Sub

    Private Sub FileSendThreRun()
        Dim n As Integer = 1
        For Each f As String In FileList
            Flag = True
            Dim fi As FileInfo = New FileInfo(f)
            filename = fi.Name
            Dim DTime As String = System.DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss")
            fs = New FileStream(f, FileMode.Open, FileAccess.Read)
            Dim buf As Byte() = New Byte(fs.Length) {}
            fs.Read(buf, 0, buf.Length)
            fs.Close()
            Dim mypacket As mook_Packet.Packet = New mook_Packet.Packet(filename, buf.Length, buf, DTime)
            client = New TcpClient()
            client.Connect(ip, port)
            ns = client.GetStream()
            myRead = New StreamReader(ns)
            myReader = New Thread(AddressOf Receive)
            myReader.Start()

            Dim writer As BinaryWriter = New BinaryWriter(ns)
            Dim data As Byte() = ObjectToBytes(mypacket)
            writer.Write(data.Length)
            writer.Write(data)
            Invoke(OnCount, n)
            While True
                If Not Flag Then Exit While
                Thread.Sleep(1)
            End While
            n += 1
        Next
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        OnMsg = New OnMessageDelegate(AddressOf OnMsgRun)
        OnCount = New OnCountDelegate(AddressOf OnCountRun)
    End Sub

    Private Sub OnCountRun(ByVal i As Integer)
        Me.tspgrBar.Value = i
    End Sub

    Private Sub OnMsgRun(ByVal s As String)
        Me.tsslblMsg.Text = String.Format("결과 : {0} 전송 완료", s)
        Flag = False
    End Sub

    Private Function ObjectToBytes(ByVal obj As Object) As Byte()
        Dim bf As BinaryFormatter = New BinaryFormatter()
        Dim MS As MemoryStream = New MemoryStream()
        bf.Serialize(MS, obj)
        Return MS.ToArray()
    End Function

    Private Sub Receive()
        While True
            Thread.Sleep(1)
            If ns.CanRead Then
                Dim msg As String = ""
                Try
                    msg = myRead.ReadLine()
                    Invoke(OnMsg, msg)
                Catch ex As Exception

                End Try
            End If
        End While
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If client IsNot Nothing Then client.Close()
        If FileSendThre IsNot Nothing Then FileSendThre.Abort()
    End Sub
End Class
