﻿Imports System.Net.NetworkInformation
Imports System.IO
Imports System.Threading
Imports System.Runtime.InteropServices

Public Class Form1
    Private Shared staticForm As Form1 '폼2에서 입력한 정보 반영
    Public Sub New()
        InitializeComponent()
        staticForm = Me
    End Sub

    Public HostNameEntry As String = "" '호스트 아이피
    Public DescriptionEntry As String = "" '호스트 설명
    Public Shared Hostcount As Integer = 0 '네트워크 체크 호스트 수

    Private pingSender As Ping = New Ping()
    Private options As PingOptions = New PingOptions()
    Private data As String = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" '32바이트
    Private Const timeout As Integer = 120 '네트워크 체크를 위한 타임아웃

    Private SoundPlayThread As Thread = Nothing '사운드 실행 스레드 개체 생성

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.tslcbTime.Text = "5 초"
        MainConfig()
    End Sub

    Private Sub MainConfig()
        If File.Exists("ICMPConfig.ini") = True Then
            Dim ss As String = String.Empty
            Using sr As StreamReader = New StreamReader("ICMPConfig.ini")
                ss = sr.ReadLine()
                While ss IsNot Nothing
                    HostNameEntry = sr.ReadLine()
                    DescriptionEntry = sr.ReadLine()
                    AddList(HostNameEntry, DescriptionEntry)
                    ss = sr.ReadLine()
                End While
                sr.Close()
            End Using
        End If
    End Sub

    Public Shared Sub AddList(ByVal AnyHostEntry As String, ByVal DescriptionEntry As String)
        Dim Entry As String() = New String(8) {}
        Entry(0) = AnyHostEntry
        Entry(1) = DescriptionEntry
        Dim hold As Integer = 0
        Dim Entries As ListViewItem = New ListViewItem(Entry)
        staticForm.lvStatus.Items.Add(Entries)
        Hostcount = Hostcount + 1
        For column As Integer = 2 To 6
            If column < 6 Then
                staticForm.lvStatus.Items(Hostcount - 1).SubItems(column).Text = hold.ToString()
            Else
                staticForm.lvStatus.Items(Hostcount - 1).SubItems(column).Text = ""
            End If
        Next
        staticForm.lvStatus.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent)
        staticForm.lvStatus.AutoResizeColumns(ColumnHeaderAutoResizeStyle.HeaderSize)
    End Sub

    Private Sub tslcbTime_Click(sender As Object, e As EventArgs) Handles tslcbTime.Click
        Select Case Me.tslcbTime.Text
            Case "5 초"
                Me.Timer.Interval = 5000
            Case "10 초"
                Me.Timer.Interval = 10000
            Case "15 초"
                Me.Timer.Interval = 15000
            Case "20 초"
                Me.Timer.Interval = 20000
            Case "30 초"
                Me.Timer.Interval = 30000
        End Select
    End Sub

    Private Sub tlsBar_ItemClicked(sender As Object, e As ToolStripItemClickedEventArgs) Handles tlsBar.ItemClicked
        Dim itemname As String = e.ClickedItem.Text
        Select Case itemname
            Case "AddHost"
                Dim frm2 As Form2 = New Form2()
                frm2.ShowDialog()
            Case "Start"
                Me.Timer.Enabled = True
                tsslblStatus.Text = "상태 : 시작 "
            Case "Stop"
                Me.Timer.Enabled = False
                tsslblStatus.Text = "상태 : 정지 "
        End Select
    End Sub

    Private Sub Timer_Tick(sender As Object, e As EventArgs) Handles Timer.Tick
        If Me.lvStatus.Items.Count = 0 Then
            MessageBox.Show("체크할 IP 정보가 없습니다.", "알림",
                    MessageBoxButtons.OK, MessageBoxIcon.Error)
            Me.Timer.Enabled = False
        Else
            Dim buffer As Byte() = System.Text.Encoding.ASCII.GetBytes(data)
            options.DontFragment = True

            For i As Integer = 0 To Me.lvStatus.Items.Count - 1
                Dim reply As PingReply = pingSender.Send(Me.lvStatus.Items(i).SubItems(0).Text, timeout, buffer, options)

                For column As Integer = 2 To 6
                    If reply.Status = IPStatus.Success Then
                        Me.lvStatus.Items(i).BackColor = Color.Yellow
                        Dim PingResult As String() = New String() {DateTime.Now.ToString(), reply.Buffer.Length.ToString() + " Bytes",
                                reply.RoundtripTime.ToString() + " ms", reply.Options.Ttl.ToString()}
                        If column < 6 Then
                            Me.lvStatus.Items(i).SubItems(column).Text = PingResult(column - 2)
                        Else
                            Me.lvStatus.Items(i).SubItems(column).Text = "성공"
                        End If
                    Else
                        If (column < 6) Then
                            Me.lvStatus.Items(i).SubItems(column).Text = (0).ToString()
                        Else
                            Me.lvStatus.Items(i).SubItems(column).Text = "실패"
                        End If
                        Me.lvStatus.Items(i).BackColor = Color.Red
                        SoundPlayThread = New Thread(AddressOf SoundPlayGo)
                        SoundPlayThread.Start()
                    End If
                Next
            Next
            Me.lvStatus.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent)
            Me.lvStatus.AutoResizeColumns(ColumnHeaderAutoResizeStyle.HeaderSize)
        End If
    End Sub

    Private Sub SoundPlayGo()
        SoundPlay.PlaySoundStart(Application.StartupPath + "\wav\ping.wav", New System.IntPtr(), SoundPlay.PlaySoundFlags.SND_SYNC)
        SoundPlayThread.Abort()
    End Sub
End Class

Public Class SoundPlay
    <DllImport("winmm.DLL", EntryPoint:="PlaySound", SetLastError:=True)>
    Public Shared Function PlaySoundStart(ByVal szSound As String, ByVal hMod As System.IntPtr,
                                      ByVal flags As PlaySoundFlags) As Boolean
    End Function
    Public Enum PlaySoundFlags As Integer
        SND_SYNC = 0
        SND_ASYNC = 1
        SND_NODEFAULT = 2
        SND_LOOP = 8
        SND_NOSTOP = 10
        SND_NOWAIT = 2000
        SND_FILENAME = 20000
        SND_RESOURCE = 40004
    End Enum
End Class



