﻿Imports System.Net 'WebClient 클래스 사용
Imports System.Xml ' XmlDocument, XmlNodeList 클래스 사용
Imports System.IO 'StringReader 클래스 사용
Imports System.Threading '스레드 클래스 사용

Public Class Form1
    Private Const NameURL = "http://localhost/" '주소 저장
    Private Const WeatherURL = "http://www.kma.go.kr/XML/weather/sfc_web_map.xml" '주소저장
    Private news = New Dictionary(Of String, String)
    Private NewcheckThread As Thread  '스레드 개체 생성
    Private Delegate Sub OnXmlDelegate(ByVal k As String, ByVal v As String)
    Private OnXml As OnXmlDelegate = Nothing '델리게이트 선언

    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        Me.lvFile.Items.Clear()

        Dim wc = New WebClient()
        Dim buffer = wc.DownloadString(String.Format("{0}WebXml.xml", NameURL))
        wc.Dispose()

        Dim sr As StringReader = New StringReader(buffer)
        Dim doc As XmlDocument = New XmlDocument()
        doc.Load(sr)
        sr.Close()

        Dim SubNodes As XmlNodeList = doc.SelectNodes("xml_reply/human/human_entry")

        For Each node As XmlNode In SubNodes
            Me.lvFile.Items.Add(New ListViewItem(New String() {GetNodeValue(node, "title")}))
        Next
    End Sub

    Private Function GetNodeValue(ByVal parent As XmlNode, ByVal strXML As String) As String
        Try
            Dim attr As XmlAttribute = parent.SelectSingleNode(strXML).Attributes("Name")
            If attr.Value <> "" Then
                Return attr.Value
            End If
            Return ""
        Catch
            Return ""
        End Try
    End Function

    Public Sub GetNews()
        Try
            Dim XMLDoc As XmlDocument = New XmlDocument()
            XMLDoc.Load(WeatherURL)
            Dim nd As XmlNode = XMLDoc.DocumentElement
            For Each node As XmlNode In nd.FirstChild.ChildNodes
                Dim XmlDataKey As String = String.Format("지역 : {0} / {1} / {2}", node.InnerText, node.Attributes("desc").Value, node.Attributes("ta").Value)
                Dim XmlDataValue As String = "http://www.weather.go.kr/weather/forecast/mid-term_01.jsp"
                news.Add(XmlDataKey, XmlDataValue)
            Next
        Catch ex As Exception
            Return
        End Try
    End Sub

    Private Sub OnXmlRun(ByVal k As String, ByVal v As String)
        Me.lklblNews.Text = k
        Me.lklblNews.AccessibleDescription = v
        Me.ttipMemo.SetToolTip(lklblNews, "지역 날씨 상세보기")
    End Sub

    Private Sub DisplayNews()
        While True
            For Each Inews As KeyValuePair(Of String, String) In news
                Invoke(OnXml, Inews.Key, Inews.Value)
                Thread.Sleep(3000)
            Next
        End While
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        OnXml = New OnXmlDelegate(AddressOf OnXmlRun)
        GetNews()
        NewcheckThread = New Thread(AddressOf DisplayNews)
        NewcheckThread.Start() 'NewcheckThread 스레드 프로세스 시작
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If Not (NewcheckThread Is Nothing) Then
            Me.Dispose() '어플리케이션 리소스 해제
            NewcheckThread.Abort() '스레드 강제 종료
        End If
    End Sub

    Private Sub lklblNews_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles lklblNews.LinkClicked
        Dim myProcess As Process = New Process()
        myProcess.StartInfo.FileName = Me.lklblNews.AccessibleDescription
        myProcess.Start()
    End Sub
End Class
